'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.stateReconciler = stateReconciler;
function stateReconciler(originalState, inboundState, reducedState, _ref) {
  var debug = _ref.debug;

  if (process.env.NODE_ENV !== 'production') devKeyChecks(originalState, inboundState);

  var newState = _extends({}, reducedState, inboundState);

  if (process.env.NODE_ENV !== 'production' && debug) console.log('redux-p/stateReconciler: rehydrated keys \'' + Object.keys(inboundState).join(', ') + '\'');

  return newState;
}

function devKeyChecks(originalState, inboundState) {
  if (!inboundState) return;
  Object.keys(inboundState).forEach(function (key) {
    // check if initialState is missing a key
    if (!originalState.hasOwnProperty(key)) console.log('\n      redux-p/stateReconciler: state missing key\n      "' + key + '". state-manager will still store the rehydrated value. If you\n      removed ' + key + ' from your reducer tree, you should write a migration to\n      remove ' + key + ' from stored state. If you code-split ' + key + ' reducer, then\n      this is the expected behavior.\n    ');

    // check recently added reducer properties that may require a migration
    if (_typeof(originalState[key]) === 'object' && _typeof(inboundState[key]) === 'object') {
      var stateKeys = Object.keys(originalState[key]);
      var inboundStateKeys = Object.keys(inboundState[key]);
      stateKeys.forEach(function (checkKey) {
        if (inboundState[checkKey] === 'undefined') console.log('\n          redux-persist-state-manager/autoRehydrate: initialState for "' + key + '"\n          has property "' + checkKey + '" which is missing in rehydratedState. After\n          rehydration, "' + checkKey + '" will be null. If you recently added\n          ' + checkKey + ' to your ' + key + ' reducer, consider adding ' + checkKey + ' to a\n          state migration.\n        ');
      });
    }
  });
}